include "VVram.inc"

ext @Temp@Word
ext @Temp@Word2
ext @Temp@Word3
ext @Temp@Word4
ext @Temp@Word5

ext @Temp@Byte
ext @Temp@Byte2
ext @Temp@Byte3
ext @Temp@Byte4
ext @Temp@Byte5

Vram equ $0100
VramWidth equ 32
VramHeight equ 24
VramRowSize equ VramWidth

VramTop equ Vram+VramRowSize*2
VramTop equ Vram+VramWidth*2

ext VVramFront_, RowFlags_
ext Chars_

pVram equ @Temp@Word
pChars equ @Temp@Word2
yCount equ @Temp@Byte
xCount equ @Temp@Byte2
pVram equ @Temp@Word3
pVVram equ @Temp@Word4

flags equ @Temp@Byte4
maskBit equ @Temp@Byte5

dseg
pflags:
    defw 0


cseg
ChangeChar:
    adda #low Chars_
    staa <pChars+1
    ldaa #0
    adca #high Chars_
    staa <pChars
    ldx <pChars
    ldaa 0,x
rts


; ptr<byte> Put(ptr<byte> pVram, byte c);
dseg
Put_@Param0: public Put_@Param0
    defw 0
Put_@Param1: public Put_@Param1
    defb 0
cseg
Put_: public Put_
    psha
        ldaa Put_@Param1
        bsr ChangeChar
        ldx Put_@Param0
        staa 0,x
        inx
    pula
rts


VVramToVramRow:
    ldaa #VVramWidth
    staa <xCount
    do
        ldx <pVVram | ldaa 0,x
        inx | stx <pVVram
        bsr ChangeChar
        ldx <pVram | staa 0,x
        inx | stx <pVram
        dec <xCount
    while ne | wend
rts


; void VVramToVramAll();
VVramToVramAll_: public VVramToVramAll_
    psha | pshb
        ldx #VVramFront_ | stx <pVVram
        ldx #VramTop | stx <pVram
        
        ldaa #VVramHeight
        staa <yCount
        do
            bsr VVramToVramRow
            dec <yCount
        while ne | wend
        clr RowFlags_
        clr RowFlags_+1
        clr RowFlags_+2
    pulb | pula
rts


; void VVramToVramChanged();
VVramToVramChanged_: public VVramToVramChanged_
    psha | pshb
        ldx #RowFlags_ | stx pflags
        ldaa 0,x | staa <flags
        ldaa #1 | staa <maskBit

        ldx #VVramFront_ | stx <pVVram
        ldx #VramTop | stx <pVram
        ldaa #VVramHeight
        staa <yCount
        do
            ldaa <flags
            anda <maskBit
            if ne
                bsr VVramToVramRow
            else
                ldaa <pVVram+1 | adda #low VVramWidth | staa <pVVram+1
                ldaa <pVVram | adca #high VVramWidth | staa <pVVram

                ldaa <pVram+1 | adda #low VramRowSize | staa <pVram+1
                ldaa <pVram | adca #high VramRowSize | staa <pVram
            endif
            asl <maskBit
            if eq
                ldx pflags | inx | stx pflags
                ldaa 0,x | staa <flags
                ldaa #1 | staa <maskBit
            endif
            dec <yCount
        while ne | wend
        clr RowFlags_
        clr RowFlags_+1
        clr RowFlags_+2
    pulb | pula
rts


; ptr<byte> PrintC(ptr<byte> <pVram, byte c);
dseg
PrintC_@Param0: public PrintC_@Param0
    defw 0
PrintC_@Param1: public PrintC_@Param1
    defb 0
cseg
PrintC_: public PrintC_
    psha
        ldx PrintC_@Param0
        ldaa PrintC_@Param1
        staa 0,x
        inx
    pula
rts
